'use strict';

var utils = require('./utils.js');

function Decorator() {
  var self = this;
  this.element.classList.add('p-decorator');
  var nullable = true;
  var onValueSelect = null;
  var btnClear = document.createElement('div');
  btnClear.className = 'p-decoration p-clear';
  utils.on(btnClear, utils.Events.CLICK, function (evt) {
    evt.stopPropagation();
    self.value = null;
    self.focus();
  });
  var btnSelect = document.createElement('div');
  btnSelect.className = 'p-decoration p-select';
  utils.on(btnSelect, utils.Events.CLICK, function (evt) {
    evt.stopPropagation();
    onValueSelect.call(self, self);
  });

  function redecorate() {
    self.element.classList.remove('p-decorator-nullable-selectable');
    self.element.classList.remove('p-decorator-nullable');
    self.element.classList.remove('p-decorator-selectable');
    if (btnClear.parentNode === self.element) self.element.removeChild(btnClear);
    if (btnSelect.parentNode === self.element) self.element.removeChild(btnSelect);

    if (nullable && onValueSelect) {
      self.element.classList.add('p-decorator-nullable-selectable');
      self.element.appendChild(btnClear);
      self.element.appendChild(btnSelect);
    } else if (nullable) {
      self.element.classList.add('p-decorator-nullable');
      self.element.appendChild(btnClear);
    } else if (onValueSelect) {
      self.element.classList.add('p-decorator-selectable');
      self.element.appendChild(btnSelect);
    }
  }

  redecorate();
  Object.defineProperty(this, 'nullable', {
    get: function get() {
      return nullable;
    },
    set: function set(aValue) {
      if (nullable !== aValue) {
        nullable = aValue;
        redecorate();
      }
    }
  });
  Object.defineProperty(this, 'onValueSelect', {
    get: function get() {
      return onValueSelect;
    },
    set: function set(aValue) {
      if (onValueSelect !== aValue) {
        onValueSelect = aValue;
        redecorate();
      }
    }
  });
  Object.defineProperty(this, 'selector', {
    get: function get() {
      return btnSelect;
    }
  });
  Object.defineProperty(this, 'clearer', {
    get: function get() {
      return btnClear;
    }
  });
}

module.exports = Decorator;
